
    create table identity_obj_properties (
        IDENTITY_OBJ_ID int8 not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (IDENTITY_OBJ_ID, prop_key)
    );

    create table jbid_io (
        id int8 not null,
        NAME varchar(255) not null,
        IDENTITY_TYPE int8 not null,
        REALM int8 not null,
        primary key (id),
        unique (NAME, IDENTITY_TYPE, REALM)
    );

    create table jbid_io_attr (
        ATTRIBUTE_ID int8 not null,
        NAME varchar(255),
        IDENTITY_OBJECT_ID int8 not null,
        primary key (ATTRIBUTE_ID),
        unique (NAME, IDENTITY_OBJECT_ID)
    );

    create table jbid_io_attr_bin (
        ATTRIBUTE_ID int8 not null,
        primary key (ATTRIBUTE_ID)
    );

    create table jbid_io_attr_bin_jbid_io_bin (
        jbid_io_attr_bin_ATTRIBUTE_ID int8 not null,
        values_id int8 not null,
        primary key (jbid_io_attr_bin_ATTRIBUTE_ID, values_id),
        unique (values_id)
    );

    create table jbid_io_attr_text (
        ATTRIBUTE_ID int8 not null,
        primary key (ATTRIBUTE_ID)
    );

    create table jbid_io_attr_text_values (
        jbid_io_attr_text_ATTRIBUTE_ID int8 not null,
        element varchar(255)
    );

    create table jbid_io_bin (
        id int8 not null,
        value oid,
        primary key (id)
    );

    create table jbid_io_creden (
        id int8 not null,
        BINARY_VALUE oid,
        TEXT varchar(255),
        IDENTITY_OBJECT_ID int8 not null,
        CREDENTIAL_TYPE int8 not null,
        primary key (id),
        unique (CREDENTIAL_TYPE, IDENTITY_OBJECT_ID)
    );

    create table jbid_io_creden_props (
        CREDENTIAL_ID int8 not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (CREDENTIAL_ID, prop_key)
    );

    create table jbid_io_creden_type (
        id int8 not null,
        NAME varchar(255) unique,
        primary key (id)
    );

    create table jbid_io_realm_props (
        REALM_ID int8 not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALM_ID, prop_key)
    );

    create table jbid_io_rel (
        id int8 not null,
        FROM_IDENTITY int8 not null,
        NAME int8,
        TO_IDENTITY int8 not null,
        TYPE int8 not null,
        primary key (id),
        unique (NAME, TYPE, FROM_IDENTITY, TO_IDENTITY)
    );

    create table jbid_io_rel_name (
        id int8 not null,
        NAME varchar(255) not null unique,
        REALM int8 not null,
        primary key (id),
        unique (NAME, REALM)
    );

    create table jbid_io_rel_name_props (
        REALATIONSHIP_NAME_ID int8 not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALATIONSHIP_NAME_ID, prop_key)
    );

    create table jbid_io_rel_props (
        REALATIONSHIP_ID int8 not null,
        PROPERTY varchar(255),
        prop_key varchar(255) not null,
        primary key (REALATIONSHIP_ID, prop_key)
    );

    create table jbid_io_rel_type (
        id int8 not null,
        name varchar(255) not null unique,
        primary key (id)
    );

    create table jbid_io_type (
        id int8 not null,
        name varchar(255) not null unique,
        primary key (id)
    );

    create table jbid_realm (
        id int8 not null,
        NAME varchar(255) not null,
        primary key (id),
        unique (NAME)
    );

    alter table identity_obj_properties 
        add constraint FK4565EF1C7FD4BF0F 
        foreign key (IDENTITY_OBJ_ID) 
        references jbid_io;

    alter table jbid_io 
        add constraint FK94860092842CE3F0 
        foreign key (REALM) 
        references jbid_realm;

    alter table jbid_io 
        add constraint FK94860092DA527B00 
        foreign key (IDENTITY_TYPE) 
        references jbid_io_type;

    alter table jbid_io_attr 
        add constraint FK4DC61D7EBFDBFEE5 
        foreign key (IDENTITY_OBJECT_ID) 
        references jbid_io;

    alter table jbid_io_attr_bin 
        add constraint FK9A8BDAC6D110A16F 
        foreign key (ATTRIBUTE_ID) 
        references jbid_io_attr;

    alter table jbid_io_attr_bin_jbid_io_bin 
        add constraint FKF39453E1249F3B99 
        foreign key (values_id) 
        references jbid_io_bin;

    alter table jbid_io_attr_bin_jbid_io_bin 
        add constraint FKF39453E11745EB87 
        foreign key (jbid_io_attr_bin_ATTRIBUTE_ID) 
        references jbid_io_attr_bin;

    alter table jbid_io_attr_text 
        add constraint FKB6F79F4ED110A16F 
        foreign key (ATTRIBUTE_ID) 
        references jbid_io_attr;

    alter table jbid_io_attr_text_values 
        add constraint FKC6F8C7336D68F593 
        foreign key (jbid_io_attr_text_ATTRIBUTE_ID) 
        references jbid_io_attr_text;

    alter table jbid_io_creden 
        add constraint FKF7FB3EC44EF15A3E 
        foreign key (CREDENTIAL_TYPE) 
        references jbid_io_creden_type;

    alter table jbid_io_creden 
        add constraint FKF7FB3EC4BFDBFEE5 
        foreign key (IDENTITY_OBJECT_ID) 
        references jbid_io;

    alter table jbid_io_creden_props 
        add constraint FKBAD64835DF01FC5 
        foreign key (CREDENTIAL_ID) 
        references jbid_io_creden;

    alter table jbid_io_realm_props 
        add constraint FKBB6DB3934A7D622C 
        foreign key (REALM_ID) 
        references jbid_realm;

    alter table jbid_io_rel 
        add constraint FKE9BC4F6CD5BB51F7 
        foreign key (TYPE) 
        references jbid_io_rel_type;

    alter table jbid_io_rel 
        add constraint FKE9BC4F6CD5B52899 
        foreign key (NAME) 
        references jbid_io_rel_name;

    alter table jbid_io_rel 
        add constraint FKE9BC4F6CB097E0BE 
        foreign key (FROM_IDENTITY) 
        references jbid_io;

    alter table jbid_io_rel 
        add constraint FKE9BC4F6CC52050D 
        foreign key (TO_IDENTITY) 
        references jbid_io;

    alter table jbid_io_rel_name 
        add constraint FK5856A77E842CE3F0 
        foreign key (REALM) 
        references jbid_realm;

    alter table jbid_io_rel_name_props 
        add constraint FK224ABD6FB176E3F1 
        foreign key (REALATIONSHIP_NAME_ID) 
        references jbid_io_rel_name;

    alter table jbid_io_rel_props 
        add constraint FKB2A23ADD8A45DAEA 
        foreign key (REALATIONSHIP_ID) 
        references jbid_io_rel;

    create sequence hibernate_sequence;
